Index: trunk/LMDZ.TITAN/libf/phytitan/optcv.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/optcv.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/optcv.F90	(revision 3083)
@@ -1,4 +1,5 @@
-SUBROUTINE OPTCV(PQMO,NLAY,PLEV,TMID,PMID,  &
-     DTAUV,TAUV,TAUCUMV,WBARV,COSBV,TAURAY,TAUGSURF,SEASHAZEFACT)
+SUBROUTINE OPTCV(PQMO,NLAY,ZLEV,PLEV,TMID,PMID,  &
+     DTAUV,TAUV,TAUCUMV,WBARV,COSBV,TAURAY,TAUGSURF,SEASHAZEFACT,&
+     POPT_HAZE,POPT_CLOUDS,CDCOLUMN)
 
   use radinc_h
@@ -7,8 +8,9 @@
   use gases_h
   use datafile_mod, only: haze_opt_file
-  use comcstfi_mod, only: r
-  use callkeys_mod, only: continuum,graybody,callgasvis,corrk_recombin,     &
-                          callclouds,callmufi,seashaze,uncoupl_optic_haze
-  use tracer_h, only: nmicro,nice
+  use comcstfi_mod, only: pi,r
+  use callkeys_mod, only: continuum,graybody,callgasvis,corrk_recombin,   &
+                          callclouds,callmufi,seashaze,uncoupl_optic_haze,&
+                          opt4clouds,FHVIS, Fssa
+  use tracer_h, only: nmicro,nice,ices_indx
 
   implicit none
@@ -24,4 +26,7 @@
   !     Adapted from the NASA Ames code by R. Wordsworth (2009)
   !     Clean and adaptation to Titan by J. Vatant d'Ollone (2016-17)
+  !     Clean and correction to Titan by B. de Batz de Trenquelléon (2022)
+  !     New optics added for Titan's clouds by B. de Batz de Trenquelléon (2023)
+  !     The whole routine needs to be redone...
   !     
   !==================================================================
@@ -47,8 +52,10 @@
   REAL*8, INTENT(IN)  :: PQMO(nlay,nmicro)  ! Tracers for microphysics optics (X/m2).
   INTEGER, INTENT(IN) :: NLAY               ! Number of pressure layers (for pqmo)
+  REAL*8, INTENT(IN)  :: ZLEV(NLAY+1)
   REAL*8, INTENT(IN)  :: PLEV(L_LEVELS)
   REAL*8, INTENT(IN)  :: TMID(L_LEVELS), PMID(L_LEVELS)
   REAL*8, INTENT(IN)  :: TAURAY(L_NSPECTV)
   REAL*8, INTENT(IN)  :: SEASHAZEFACT(L_LEVELS)
+  INTEGER, INTENT(IN) :: CDCOLUMN
   
   REAL*8, INTENT(OUT) :: DTAUV(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
@@ -58,4 +65,6 @@
   REAL*8, INTENT(OUT) :: WBARV(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
   REAL*8, INTENT(OUT) :: TAUGSURF(L_NSPECTV,L_NGAUSS-1)
+  REAL*8, INTENT(OUT) :: POPT_HAZE(L_LEVELS,L_NSPECTI,3)
+  REAL*8, INTENT(OUT) :: POPT_CLOUDS(L_LEVELS,L_NSPECTI,3)
   ! ==========================================================
   
@@ -64,8 +73,8 @@
   ! Titan customisation
   ! J. Vatant d'Ollone (2016)
-  real*8 DHAZE_T(L_LEVELS,L_NSPECTI)
-  real*8 DHAZES_T(L_LEVELS,L_NSPECTI)
-  real*8 SSA_T(L_LEVELS,L_NSPECTI)
-  real*8 ASF_T(L_LEVELS,L_NSPECTI)
+  real*8 DHAZE_T(L_LEVELS,L_NSPECTV)
+  real*8 DHAZES_T(L_LEVELS,L_NSPECTV)
+  real*8 SSA_T(L_LEVELS,L_NSPECTV)
+  real*8 ASF_T(L_LEVELS,L_NSPECTV)
   ! ==========================
 
@@ -105,9 +114,13 @@
   real*8  dumwvl
 
-  real*8 m3as,m3af
-  real*8 dtauaer_s,dtauaer_f
+  ! Variables for new optics
+  integer iq, iw, FTYPE, CTYPE
+  real*8 m0as,m0af,m0ccn,m3as,m3af,m3ccn,m3ices,m3cld
+  real*8 dtauaer_s,dtauaer_f,dtau_ccn,dtau_cld
   real*8,save :: rhoaer_s(L_NSPECTV),ssa_s(L_NSPECTV),asf_s(L_NSPECTV)
   real*8,save :: rhoaer_f(L_NSPECTV),ssa_f(L_NSPECTV),asf_f(L_NSPECTV)
-!$OMP THREADPRIVATE(rhoaer_s,rhoaer_f,ssa_s,ssa_f,asf_s,asf_f)
+  real*8,save :: ssa_ccn(L_NSPECTI),asf_ccn(L_NSPECTI)
+  real*8,save :: ssa_cld(L_NSPECTV),asf_cld(L_NSPECTV)
+!$OMP THREADPRIVATE(rhoaer_s,rhoaer_f,ssa_s,ssa_f,ssa_cld,asf_s,asf_f,asf_cld)
   
   logical,save :: firstcall=.true.
@@ -141,200 +154,325 @@
   ENDIF
 
-  !=======================================================================
-  !     Determine the total gas opacity throughout the column, for each
-  !     spectral interval, NW, and each Gauss point, NG.
-  !     Calculate the continuum opacities, i.e., those that do not depend on
-  !     NG, the Gauss index.
-
-  taugsurf(:,:) = 0.0
-  dpr(:)        = 0.0
-  lkcoef(:,:)   = 0.0
-
-  do K=2,L_LEVELS
-  
-     ilay = L_NLAYRAD+1 - k/2 ! int. arithmetic => gives the gcm layer index (reversed)
-  
-     DPR(k) = PLEV(K)-PLEV(K-1)
-
-     ! if we have continuum opacities, we need dz
-
+   !=======================================================================
+   !     Determine the total gas opacity throughout the column, for each
+   !     spectral interval, NW, and each Gauss point, NG.
+   !     Calculate the continuum opacities, i.e., those that do not depend on
+   !     NG, the Gauss index.
+
+   taugsurf(:,:) = 0.0
+   dpr(:)        = 0.0
+   lkcoef(:,:)   = 0.0
+
+   do K=2,L_LEVELS
+      ilay = L_NLAYRAD+1 - k/2 ! int. arithmetic => gives the gcm layer index (reversed)
+      DPR(k) = PLEV(K)-PLEV(K-1)
+
+      ! if we have continuum opacities, we need dz
       dz(k) = dpr(k)*R*TMID(K)/(gzlat_ig(ilay)*PMID(K))
       U(k)  = Cmk(ilay)*DPR(k)     ! only Cmk line in optcv.F     
 
-     call tpindex(PMID(K),TMID(K),pfgasref,tgasref,LCOEF,MT(K),MP(K))
-
-     do LK=1,4
-        LKCOEF(K,LK) = LCOEF(LK)
-     end do
-  end do                    ! levels
-
-  ! Rayleigh scattering
-  do NW=1,L_NSPECTV
-     TRAY(1:4,NW)   = 1.d-30
-     do K=5,L_LEVELS
-        TRAY(K,NW)   = TAURAY(NW) * DPR(K)
-     end do                    ! levels
-  end do
-  
-  !     we ignore K=1...
-  do K=2,L_LEVELS
-  
-     ilay = L_NLAYRAD+1 - k/2 ! int. arithmetic => gives the gcm layer index (reversed)
-
-     do NW=1,L_NSPECTV
-     
-        IF (callmufi .AND. (.NOT. uncoupl_optic_haze)) THEN
-          m3as = pqmo(ilay,2) / 2.0
-          m3af = pqmo(ilay,4) / 2.0
-          
-          IF ( ilay .lt. 18 ) THEN
-            m3as = pqmo(18,2) / 2.0 * dz(k) / dz(18)
-            m3af = pqmo(18,4) / 2.0 * dz(k) / dz(18)
-          ENDIF
-
-          dtauaer_s     = m3as*rhoaer_s(nw)
-          dtauaer_f     = m3af*rhoaer_f(nw)
-          DHAZE_T(k,nw) = dtauaer_s + dtauaer_f
-
-          IF ( dtauaer_s + dtauaer_f .GT. 1.D-30 ) THEN
-            SSA_T(k,nw)   = ( dtauaer_s*ssa_s(nw) + dtauaer_f*ssa_f(nw) ) / ( dtauaer_s+dtauaer_f )
-            ASF_T(k,nw)   = ( dtauaer_s*ssa_s(nw)*asf_s(nw) + dtauaer_f*ssa_f(nw)*asf_f(nw) )  &
-                            / ( ssa_s(nw)*dtauaer_s + ssa_f(nw)*dtauaer_f )
-          ELSE
-             DHAZE_T(k,nw) = 0.D0
-             SSA_T(k,nw)   = 1.0
-             ASF_T(k,nw)   = 1.0
-          ENDIF
-          
-          IF (callclouds.and.firstcall) & 
-            WRITE(*,*) 'WARNING: In optcv, optical properties &
-                       &calculations are not implemented yet'
-        ELSE
-          ! Call fixed vertical haze profile of extinction - same for all columns
-          call disr_haze(dz(k),plev(k),wnov(nw),DHAZE_T(k,nw),SSA_T(k,nw),ASF_T(k,nw))
-          if (seashaze) DHAZE_T(k,nw) = DHAZE_T(k,nw)*seashazefact(k)
-        ENDIF
-        
-        !JL18 It seems to be good to have aerosols in the first "radiative layer" of the gcm in the IR
-        !   but visible does not handle very well diffusion in first layer.
-        !   The tauaero and tauray are thus set to 0 (a small value for rayleigh because the code crashes otherwise)
-        !   in the 4 first semilayers in optcv, but not optci.
-        !   This solves random variations of the sw heating at the model top. 
-        if (k<5)  DHAZE_T(K,:) = 0.0
+      call tpindex(PMID(K),TMID(K),pfgasref,tgasref,LCOEF,MT(K),MP(K))
+
+      do LK=1,4
+         LKCOEF(K,LK) = LCOEF(LK)
+      end do
+   end do ! L_LEVELS
+
+   ! Rayleigh scattering
+   do NW=1,L_NSPECTV
+      TRAY(1:4,NW)   = 1.d-30
+      do K=5,L_LEVELS
+         TRAY(K,NW)   = TAURAY(NW) * DPR(K)
+      end do ! L_LEVELS
+   end do
+  
+   do NW=1,L_NSPECTV
+      ! We ignore K=1...
+      do K=2,L_LEVELS
+         ! int. arithmetic => gives the gcm layer index (reversed)
+         ilay = L_NLAYRAD+1 - k/2
          
-        DRAYAER = TRAY(K,NW)
-        !     DRAYAER is Tau RAYleigh scattering, plus AERosol opacity
-        DRAYAER = DRAYAER + DHAZE_T(K,NW) ! Titan's aerosol
-
-        DCONT = 0.0 ! continuum absorption
-
-        if(continuum.and.(.not.graybody).and.callgasvis)then
-           ! include continua if necessary
-           wn_cont = dble(wnov(nw))
-           T_cont  = dble(TMID(k))
-           do igas=1,ngasmx
-
-              p_cont  = dble(PMID(k)*scalep*gfrac(igas,ilay))
-
-              dtemp=0.0
-              if(igas.eq.igas_N2)then
-
-                 interm = indv(nw,igas,igas)
-!                 call interpolateN2N2(wn_cont,T_cont,p_cont,dtemp,.false.,interm)
-                 indv(nw,igas,igas) = interm
-                 ! only goes to 500 cm^-1, so unless we're around a cold brown dwarf, this is irrelevant in the visible
-
-              elseif(igas.eq.igas_H2)then
-
-                 ! first do self-induced absorption
-                 interm = indv(nw,igas,igas)
-                 call interpolateH2H2(wn_cont,T_cont,p_cont,dtemp,.false.,interm)
-                 indv(nw,igas,igas) = interm
-
-                 ! then cross-interactions with other gases
-                 do jgas=1,ngasmx
-                    p_cross = dble(PMID(k)*scalep*gfrac(jgas,ilay))
-                    dtempc  = 0.0
-                    if(jgas.eq.igas_N2)then 
-                       interm = indv(nw,igas,jgas)
-                       call interpolateN2H2(wn_cont,T_cont,p_cross,p_cont,dtempc,.false.,interm)
-                       indv(nw,igas,jgas) = interm
-                       ! should be irrelevant in the visible
-                    endif
-                    dtemp = dtemp + dtempc
-                 enddo
-
-               elseif(igas.eq.igas_CH4)then
-
-                 ! first do self-induced absorption
-                 interm = indv(nw,igas,igas)
-                 call interpolateCH4CH4(wn_cont,T_cont,p_cont,dtemp,.false.,interm)
-                 indv(nw,igas,igas) = interm
-
-                 ! then cross-interactions with other gases
-                 do jgas=1,ngasmx
-                    p_cross = dble(PMID(k)*scalep*gfrac(jgas,ilay))
-                    dtempc  = 0.0
-                    if(jgas.eq.igas_N2)then 
-                       interm = indv(nw,igas,jgas)
-                       call interpolateN2CH4(wn_cont,T_cont,p_cross,p_cont,dtempc,.false.,interm)
-                       indv(nw,igas,jgas) = interm
-                    endif
-                    dtemp = dtemp + dtempc
-                 enddo
-
-              endif
-
-              DCONT = DCONT + dtemp
-
-           enddo
-
-           DCONT = DCONT*dz(k)
-
-        endif
-
-        do ng=1,L_NGAUSS-1
-
-           ! Now compute TAUGAS
-
-           ! JVO 2017 : added tmpk because the repeated calls to gasi/v increased dramatically
-           ! the execution time of optci/v -> ~ factor 2 on the whole radiative
-           ! transfer on the tested simulations !
-
-           if (corrk_recombin) then 
-             tmpk = GASV_RECOMB(MT(K):MT(K)+1,MP(K):MP(K)+1,NW,NG)
-           else
-             tmpk = GASV(MT(K):MT(K)+1,MP(K):MP(K)+1,1,NW,NG)
-           endif
-              
-           KCOEF(1) = tmpk(1,1) ! KCOEF(1) = GASV(MT(K),MP(K),1,NW,NG)
-           KCOEF(2) = tmpk(1,2) ! KCOEF(2) = GASV(MT(K),MP(K)+1,1,NW,NG)
-           KCOEF(3) = tmpk(2,2) ! KCOEF(3) = GASV(MT(K)+1,MP(K)+1,1,NW,NG)
-           KCOEF(4) = tmpk(2,1) ! KCOEF(4) = GASV(MT(K)+1,MP(K),1,NW,NG)
-
-           ! Interpolate the gaseous k-coefficients to the requested T,P values
-
-           ANS = LKCOEF(K,1)*KCOEF(1) + LKCOEF(K,2)*KCOEF(2) +            &
-                LKCOEF(K,3)*KCOEF(3) + LKCOEF(K,4)*KCOEF(4)
-
-
-           TAUGAS  = U(k)*ANS
-
-           TAUGSURF(NW,NG) = TAUGSURF(NW,NG) + TAUGAS + DCONT
-           DTAUKV(K,nw,ng) = TAUGAS & 
-                             + DRAYAER & ! DRAYAER includes all scattering contributions
-                             + DCONT ! For parameterized continuum aborption
-
-        end do
-
-        ! Now fill in the "clear" part of the spectrum (NG = L_NGAUSS),
-        ! which holds continuum opacity only
-
-        NG              = L_NGAUSS
-        DTAUKV(K,nw,ng) = DRAYAER + DCONT ! Scattering + parameterized continuum absorption, including Titan's haze
-
-     end do
-  end do
-
+         ! Optics coupled with the microphysics :
+         IF (callmufi .AND. (.NOT. uncoupl_optic_haze)) THEN
+
+            !==========================================================================================
+            ! Old optics (must have callclouds = .false.):
+            !==========================================================================================
+            IF (.NOT. opt4clouds) THEN
+               m3as = pqmo(ilay,2) / 2.0
+               m3af = pqmo(ilay,4) / 2.0
+               ! Cut-off
+               IF (ilay .lt. 19) THEN
+                  m3as = pqmo(19,2) / 2.0 * (zlev(ilay+1)-zlev(ilay)) / (zlev(20)-zlev(19))
+                  m3af = pqmo(19,4) / 2.0 * (zlev(ilay+1)-zlev(ilay)) / (zlev(20)-zlev(19))
+               ENDIF
+               
+               dtauaer_s = m3as*rhoaer_s(nw)
+               dtauaer_f = m3af*rhoaer_f(nw)
+
+            !==========================================================================================
+            ! New optics :
+            !==========================================================================================
+            ELSE
+               iw = (L_NSPECTV + 1) - NW ! Visible first and return
+               !-----------------------------
+               ! HAZE (Spherical + Fractal) :
+               !-----------------------------
+               FTYPE = 1
+
+               ! Spherical aerosols :
+               !---------------------
+               CTYPE = 5
+               m0as  = pqmo(ilay,1) / 2.0
+               m3as  = pqmo(ilay,2) / 2.0
+               ! If not callclouds : must have a cut-off
+               IF (.NOT. callclouds) THEN
+                  IF (ilay .lt. 19) THEN
+                     m0as = pqmo(19,1) / 2.0 * (zlev(ilay+1)-zlev(ilay)) / (zlev(20)-zlev(19))
+                     m3as = pqmo(19,2) / 2.0 * (zlev(ilay+1)-zlev(ilay)) / (zlev(20)-zlev(19))
+                  ENDIF
+               ENDIF
+               call get_haze_and_cloud_opacity(FTYPE,CTYPE,m0as,m3as,iw,dtauaer_s,ssa_s(nw),asf_s(nw))
+
+               ! Fractal aerosols :
+               !-------------------
+               CTYPE = FTYPE
+               m0af  = pqmo(ilay,3) / 2.0
+               m3af  = pqmo(ilay,4) / 2.0
+               ! If not callclouds : must have a cut-off
+               IF (.NOT. callclouds) THEN
+                  IF (ilay .lt. 19) THEN
+                     m0af = pqmo(19,3) / 2.0 * (zlev(ilay+1)-zlev(ilay)) / (zlev(20)-zlev(19))
+                     m3af = pqmo(19,4) / 2.0 * (zlev(ilay+1)-zlev(ilay)) / (zlev(20)-zlev(19))
+                  ENDIF
+               ENDIF
+               call get_haze_and_cloud_opacity(FTYPE,CTYPE,m0af,m3af,iw,dtauaer_f,ssa_f(nw),asf_f(nw))
+            ENDIF
+
+            ! Total of Haze opacity (dtau), SSA (w) and ASF (COS) :
+            DHAZE_T(k,nw) = dtauaer_s + dtauaer_f
+            IF (dtauaer_s + dtauaer_f .GT. 1.D-30) THEN
+               SSA_T(k,nw) = ( dtauaer_s*ssa_s(nw) + dtauaer_f*ssa_f(nw) ) / ( dtauaer_s+dtauaer_f )
+               ASF_T(k,nw) = ( dtauaer_s*ssa_s(nw)*asf_s(nw) + dtauaer_f*ssa_f(nw)*asf_f(nw) )  &
+                             / ( ssa_s(nw)*dtauaer_s + ssa_f(nw)*dtauaer_f )
+            ELSE
+               DHAZE_T(k,nw) = 0.D0
+               SSA_T(k,nw)   = 1.0
+               ASF_T(k,nw)   = 1.0
+            ENDIF
+            ! Diagnostics for the haze :
+            POPT_HAZE(k,nw,1) = DHAZE_T(k,nw) ! dtau
+            POPT_HAZE(k,nw,2) = SSA_T(k,nw)   ! wbar
+            POPT_HAZE(k,nw,3) = ASF_T(k,nw)   ! gbar
+
+            !---------------------
+            ! CLOUDS (Spherical) :
+            !---------------------
+            IF (callclouds) THEN
+               CTYPE = 0
+               m0ccn = pqmo(ilay,5) / 2.0
+               m3ccn = pqmo(ilay,6) / 2.0
+               m3ices = 0.0d0
+               m3cld  = m3ccn
+               
+               ! Clear / Dark column method :
+               !-----------------------------
+
+               ! CCN's SSA :
+               call get_haze_and_cloud_opacity(FTYPE,FTYPE,m0ccn,m3ccn,iw,dtau_ccn,ssa_ccn(nw),asf_ccn(nw))
+
+               ! Clear column (CCN, C2H2, C2H6, HCN) :
+               IF (CDCOLUMN == 0) THEN
+                  DO iq = 2, nice
+                     m3ices = m3ices + (pqmo(ilay,ices_indx(iq)) / 2.0)
+                     m3cld  = m3cld + (pqmo(ilay,ices_indx(iq)) / 2.0)
+                  ENDDO
+                  call get_haze_and_cloud_opacity(FTYPE,CTYPE,m0ccn,m3cld,iw,dtau_cld,ssa_cld(nw),asf_cld(nw))
+               
+               ! Dark column (CCN, CH4, C2H2, C2H6, HCN) :
+               ELSEIF (CDCOLUMN == 1) THEN
+                  DO iq = 1, nice
+                     m3ices = m3ices + (pqmo(ilay,ices_indx(iq)) / 2.0)
+                     m3cld  = m3cld + (pqmo(ilay,ices_indx(iq)) / 2.0)
+                  ENDDO
+                  call get_haze_and_cloud_opacity(FTYPE,CTYPE,m0ccn,m3cld,iw,dtau_cld,ssa_cld(nw),asf_cld(nw))
+               
+               ELSE
+                  WRITE(*,*) 'WARNING OPTCV.F90 : CDCOLUMN MUST BE 0 OR 1'
+                  WRITE(*,*) 'WE USE DARK COLUMN ...'
+                  DO iq = 1, nice
+                     m3ices = m3ices + (pqmo(ilay,ices_indx(iq)) / 2.0)
+                     m3cld  = m3cld + (pqmo(ilay,ices_indx(iq)) / 2.0)
+                  ENDDO
+                  call get_haze_and_cloud_opacity(FTYPE,CTYPE,m0ccn,m3cld,iw,dtau_cld,ssa_cld(nw),asf_cld(nw))
+               ENDIF
+
+               ! For small dropplets, opacity of nucleus dominates
+               !ssa_cld(nw) = (ssa_ccn(nw)*m3ccn + ssa_cld(nw)*m3ices) / (m3ccn + m3ices)
+               ssa_cld(nw) = (ssa_ccn(nw)*m3ccn + ssa_cld(nw)*m3cld) / (m3ccn + m3cld)
+               ssa_cld(nw) = ssa_cld(nw) * Fssa
+
+               ! Total of Haze + Clouds opacity (dtau), SSA (w) and ASF (COS) :
+               DHAZE_T(k,nw) = dtauaer_s + dtauaer_f + dtau_cld
+               IF (DHAZE_T(k,nw) .GT. 1.D-30) THEN
+                  SSA_T(k,nw) = ( dtauaer_s*ssa_s(nw) + dtauaer_f*ssa_f(nw) + dtau_cld*ssa_cld(nw) ) / ( dtauaer_s+dtauaer_f+dtau_cld )
+                  ASF_T(k,nw) = ( dtauaer_s*ssa_s(nw)*asf_s(nw) + dtauaer_f*ssa_f(nw)*asf_f(nw) + dtau_cld*ssa_cld(nw)*asf_cld(nw) ) &
+                                / ( ssa_s(nw)*dtauaer_s + ssa_f(nw)*dtauaer_f + ssa_cld(nw)*dtau_cld )
+               ELSE
+                  DHAZE_T(k,nw) = 0.D0
+                  SSA_T(k,nw)   = 1.0
+                  ASF_T(k,nw)   = 1.0
+               ENDIF
+               
+               ! Tuning of optical properties (now useless...) :
+               DHAZE_T(k,nw) = DHAZE_T(k,nw) * (FHVIS * (1-SSA_T(k,nw)) + SSA_T(k,nw))
+               SSA_T(k,nw)   = SSA_T(k,nw) / (FHVIS * (1-SSA_T(k,nw)) + SSA_T(k,nw))
+
+               ! Diagnostics for clouds :
+               POPT_CLOUDS(k,nw,1) = DHAZE_T(k,nw) ! dtau
+               POPT_CLOUDS(k,nw,2) = SSA_T(k,nw)   ! wbar
+               POPT_CLOUDS(k,nw,3) = ASF_T(k,nw)   ! gbar
+            
+            ELSE
+               ! Diagnostics for clouds :
+               POPT_CLOUDS(k,nw,1) = 0.D0 ! dtau
+               POPT_CLOUDS(k,nw,2) = 1.0  ! wbar
+               POPT_CLOUDS(k,nw,3) = 1.0  ! gbar
+            ENDIF 
+            
+         ! Optics and microphysics no coupled :
+         ELSE
+            ! Call fixed vertical haze profile of extinction - same for all columns
+            call disr_haze(dz(k),plev(k),wnov(nw),DHAZE_T(k,nw),SSA_T(k,nw),ASF_T(k,nw))
+            if (seashaze) DHAZE_T(k,nw) = DHAZE_T(k,nw)*seashazefact(k)
+            ! Diagnostics for the haze :
+            POPT_HAZE(k,nw,1) = DHAZE_T(k,nw) ! dtau
+            POPT_HAZE(k,nw,2) = SSA_T(k,nw)   ! wbar
+            POPT_HAZE(k,nw,3) = ASF_T(k,nw)   ! gbar
+            ! Diagnostics for clouds :
+            POPT_CLOUDS(k,nw,1) = 0.D0 ! dtau
+            POPT_CLOUDS(k,nw,2) = 1.0  ! wbar
+            POPT_CLOUDS(k,nw,3) = 1.0  ! gbar
+         ENDIF ! ENDIF callmufi
+         
+         !JL18 It seems to be good to have aerosols in the first "radiative layer" of the gcm in the IR
+         !   but visible does not handle very well diffusion in first layer.
+         !   The tauaero and tauray are thus set to 0 (a small value for rayleigh because the code crashes otherwise)
+         !   in the 4 first semilayers in optcv, but not optci.
+         !   This solves random variations of the sw heating at the model top. 
+         if (k<5)  DHAZE_T(K,:) = 0.0
+         
+         DRAYAER = TRAY(K,NW)
+         ! DRAYAER is Tau RAYleigh scattering, plus AERosol opacity
+         DRAYAER = DRAYAER + DHAZE_T(K,NW) ! Titan's aerosol
+
+         DCONT = 0.0 ! continuum absorption
+
+         if(continuum.and.(.not.graybody).and.callgasvis)then
+            ! include continua if necessary
+            wn_cont = dble(wnov(nw))
+            T_cont  = dble(TMID(k))
+            do igas=1,ngasmx
+
+               p_cont  = dble(PMID(k)*scalep*gfrac(igas,ilay))
+
+               dtemp=0.0
+               if(igas.eq.igas_N2)then
+
+                  interm = indv(nw,igas,igas)
+   !                 call interpolateN2N2(wn_cont,T_cont,p_cont,dtemp,.false.,interm)
+                  indv(nw,igas,igas) = interm
+                  ! only goes to 500 cm^-1, so unless we're around a cold brown dwarf, this is irrelevant in the visible
+
+               elseif(igas.eq.igas_H2)then
+
+                  ! first do self-induced absorption
+                  interm = indv(nw,igas,igas)
+                  call interpolateH2H2(wn_cont,T_cont,p_cont,dtemp,.false.,interm)
+                  indv(nw,igas,igas) = interm
+
+                  ! then cross-interactions with other gases
+                  do jgas=1,ngasmx
+                     p_cross = dble(PMID(k)*scalep*gfrac(jgas,ilay))
+                     dtempc  = 0.0
+                     if(jgas.eq.igas_N2)then 
+                        interm = indv(nw,igas,jgas)
+                        call interpolateN2H2(wn_cont,T_cont,p_cross,p_cont,dtempc,.false.,interm)
+                        indv(nw,igas,jgas) = interm
+                        ! should be irrelevant in the visible
+                     endif
+                     dtemp = dtemp + dtempc
+                  enddo
+
+                  elseif(igas.eq.igas_CH4)then
+
+                  ! first do self-induced absorption
+                  interm = indv(nw,igas,igas)
+                  call interpolateCH4CH4(wn_cont,T_cont,p_cont,dtemp,.false.,interm)
+                  indv(nw,igas,igas) = interm
+
+                  ! then cross-interactions with other gases
+                  do jgas=1,ngasmx
+                     p_cross = dble(PMID(k)*scalep*gfrac(jgas,ilay))
+                     dtempc  = 0.0
+                     if(jgas.eq.igas_N2)then 
+                        interm = indv(nw,igas,jgas)
+                        call interpolateN2CH4(wn_cont,T_cont,p_cross,p_cont,dtempc,.false.,interm)
+                        indv(nw,igas,jgas) = interm
+                     endif
+                     dtemp = dtemp + dtempc
+                  enddo
+
+               endif
+
+               DCONT = DCONT + dtemp
+
+            enddo
+
+            DCONT = DCONT*dz(k)
+
+         endif
+
+         do ng=1,L_NGAUSS-1
+
+            ! Now compute TAUGAS
+
+            ! JVO 2017 : added tmpk because the repeated calls to gasi/v increased dramatically
+            ! the execution time of optci/v -> ~ factor 2 on the whole radiative
+            ! transfer on the tested simulations !
+
+            if (corrk_recombin) then 
+               tmpk = GASV_RECOMB(MT(K):MT(K)+1,MP(K):MP(K)+1,NW,NG)
+            else
+               tmpk = GASV(MT(K):MT(K)+1,MP(K):MP(K)+1,1,NW,NG)
+            endif
+               
+            KCOEF(1) = tmpk(1,1) ! KCOEF(1) = GASV(MT(K),MP(K),1,NW,NG)
+            KCOEF(2) = tmpk(1,2) ! KCOEF(2) = GASV(MT(K),MP(K)+1,1,NW,NG)
+            KCOEF(3) = tmpk(2,2) ! KCOEF(3) = GASV(MT(K)+1,MP(K)+1,1,NW,NG)
+            KCOEF(4) = tmpk(2,1) ! KCOEF(4) = GASV(MT(K)+1,MP(K),1,NW,NG)
+
+            ! Interpolate the gaseous k-coefficients to the requested T,P values
+
+            ANS = LKCOEF(K,1)*KCOEF(1) + LKCOEF(K,2)*KCOEF(2) +            &
+                  LKCOEF(K,3)*KCOEF(3) + LKCOEF(K,4)*KCOEF(4)
+
+
+            TAUGAS  = U(k)*ANS
+
+            TAUGSURF(NW,NG) = TAUGSURF(NW,NG) + TAUGAS + DCONT
+            DTAUKV(K,nw,ng) = TAUGAS & 
+                              + DRAYAER & ! DRAYAER includes all scattering contributions
+                              + DCONT ! For parameterized continuum aborption
+         end do
+
+         ! Now fill in the "clear" part of the spectrum (NG = L_NGAUSS),
+         ! which holds continuum opacity only
+
+         NG              = L_NGAUSS
+         DTAUKV(K,nw,ng) = DRAYAER + DCONT ! Scattering + parameterized continuum absorption, including Titan's haze
+
+      end do ! k = L_LEVELS
+   end do ! nw = L_NSPECTI
 
   !=======================================================================
@@ -355,63 +493,64 @@
   ENDDO
 
-
+  ! NW spectral loop
   DO NW=1,L_NSPECTV
-     DO L=1,L_NLAYRAD-1
-        K              = 2*L+1
-	atemp(L,NW) = ASF_T(K,NW)*DHAZES_T(K,NW) + ASF_T(K+1,NW)*DHAZES_T(K+1,NW)
-        btemp(L,NW) = DHAZES_T(K,NW) + DHAZES_T(K+1,NW)
-	ctemp(L,NW) = btemp(L,NW) + 0.9999*(TRAY(K,NW) + TRAY(K+1,NW)) ! JVO 2017 : does this 0.999 is really meaningful ?
-	btemp(L,NW) = btemp(L,NW) + TRAY(K,NW) + TRAY(K+1,NW)
-	COSBV(L,NW,1:L_NGAUSS) = atemp(L,NW)/btemp(L,NW)
-     END DO ! L vertical loop
+   ! L vertical loop
+   DO L=1,L_NLAYRAD-1
+      K = 2*L+1
+	   atemp(L,NW) = ASF_T(K,NW)*DHAZES_T(K,NW) + ASF_T(K+1,NW)*DHAZES_T(K+1,NW)
+      btemp(L,NW) = DHAZES_T(K,NW) + DHAZES_T(K+1,NW)
+	   ctemp(L,NW) = btemp(L,NW) + 0.9999*(TRAY(K,NW) + TRAY(K+1,NW)) ! JVO 2017 : does this 0.999 is really meaningful ?
+	   btemp(L,NW) = btemp(L,NW) + TRAY(K,NW) + TRAY(K+1,NW)
+      COSBV(L,NW,1:L_NGAUSS) = atemp(L,NW)/btemp(L,NW)
+   END DO
      
-     ! Last level
-     L           = L_NLAYRAD
-     K           = 2*L+1
-     atemp(L,NW) = ASF_T(K,NW)*DHAZES_T(K,NW)
-     btemp(L,NW) = DHAZES_T(K,NW)
-     ctemp(L,NW) = btemp(L,NW) + 0.9999*TRAY(K,NW) ! JVO 2017 : does this 0.999 is really meaningful ?
-     btemp(L,NW) = btemp(L,NW) + TRAY(K,NW)
-     COSBV(L,NW,1:L_NGAUSS) = atemp(L,NW)/btemp(L,NW)
-     
-     
-  END DO                    ! NW spectral loop
-
+   ! Last level
+   L = L_NLAYRAD
+   K = 2*L+1
+   atemp(L,NW) = ASF_T(K,NW)*DHAZES_T(K,NW)
+   btemp(L,NW) = DHAZES_T(K,NW)
+   ctemp(L,NW) = btemp(L,NW) + 0.9999*TRAY(K,NW) ! JVO 2017 : does this 0.999 is really meaningful ?
+   btemp(L,NW) = btemp(L,NW) + TRAY(K,NW)
+   COSBV(L,NW,1:L_NGAUSS) = atemp(L,NW)/btemp(L,NW)
+  END DO
+
+  ! NG Gauss loop
   DO NG=1,L_NGAUSS
-    DO NW=1,L_NSPECTV
-     DO L=1,L_NLAYRAD-1
-
-        K              = 2*L+1
-        DTAUV(L,nw,ng) = DTAUKV(K,NW,NG) + DTAUKV(K+1,NW,NG)
-        WBARV(L,nw,ng) = ctemp(L,NW) / DTAUV(L,nw,ng)
-
-      END DO ! L vertical loop
-
-        ! Last level
-
-        L              = L_NLAYRAD
-        K              = 2*L+1
-	DTAUV(L,nw,ng) = DTAUKV(K,NW,NG)
-
-        WBARV(L,NW,NG) = ctemp(L,NW) / DTAUV(L,NW,NG)
-
-     END DO                 ! NW spectral loop
-  END DO                    ! NG Gauss loop
+   ! NW spectral loop
+   DO NW=1,L_NSPECTV
+      ! L vertical loop
+      DO L=1,L_NLAYRAD-1
+         K = 2*L+1
+         DTAUV(L,nw,ng) = DTAUKV(K,NW,NG) + DTAUKV(K+1,NW,NG)
+         WBARV(L,nw,ng) = ctemp(L,NW) / DTAUV(L,nw,ng)
+      END DO
+
+      ! Last level
+      L = L_NLAYRAD
+      K = 2*L+1
+	   DTAUV(L,nw,ng) = DTAUKV(K,NW,NG)
+      WBARV(L,NW,NG) = ctemp(L,NW) / DTAUV(L,NW,NG)
+   END DO
+  END DO
 
   ! Total extinction optical depths
-
-  DO NG=1,L_NGAUSS       ! full gauss loop
-     DO NW=1,L_NSPECTV       
-        TAUCUMV(1,NW,NG)=0.0D0
-        DO K=2,L_LEVELS
-           TAUCUMV(K,NW,NG)=TAUCUMV(K-1,NW,NG)+DTAUKV(K,NW,NG)
-        END DO
-
-        DO L=1,L_NLAYRAD
-           TAUV(L,NW,NG)=TAUCUMV(2*L,NW,NG)
-        END DO
-        TAUV(L,NW,NG)=TAUCUMV(2*L_NLAYRAD+1,NW,NG)
-     END DO            
-  END DO                 ! end full gauss loop
+  !DO NG=1,L_NGAUSS       ! full gauss loop
+  !   DO NW=1,L_NSPECTV       
+  !      TAUCUMV(1,NW,NG)=0.0D0
+  !      DO K=2,L_LEVELS
+  !         TAUCUMV(K,NW,NG)=TAUCUMV(K-1,NW,NG)+DTAUKV(K,NW,NG)
+  !      END DO
+  !      DO L=1,L_NLAYRAD
+  !         TAUV(L,NW,NG)=TAUCUMV(2*L,NW,NG)
+  !      END DO
+  !      TAUV(L,NW,NG)=TAUCUMV(2*L_NLAYRAD+1,NW,NG)
+  !   END DO            
+  !END DO                 ! end full gauss loop
+  
+  TAUCUMV(:,:,:) = DTAUKV(:,:,:)
+  DO L=1,L_NLAYRAD
+   TAUV(L,:,:)=TAUCUMV(2*L,:,:)
+  END DO
+  TAUV(L,:,:)=TAUCUMV(2*L_NLAYRAD+1,:,:)
 
   if(firstcall) firstcall = .false.
Index: trunk/LMDZ.TITAN/libf/phytitan/phys_state_var_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/phys_state_var_mod.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/phys_state_var_mod.F90	(revision 3083)
@@ -71,4 +71,13 @@
       real,dimension(:,:,:),allocatable,save :: int_dtaui   ! IR optical thickness of layers within narrowbands for diags ().
 !$OMP THREADPRIVATE(int_dtaui,int_dtauv) 
+
+      real,dimension(:,:,:,:),allocatable,save :: zpopthi ! IR optical properties of haze within narrowbands for diags (dtau,tau,k,wbar,gbar).
+      real,dimension(:,:,:,:),allocatable,save :: zpopthv ! VI optical properties of haze within narrowbands for diags (dtau,tau,k,wbar,gbar).
+      real,dimension(:,:,:,:),allocatable,save :: zpoptci ! IR optical properties of clouds within narrowbands for diags (dtau,tau,k,wbar,gbar).
+      real,dimension(:,:,:,:),allocatable,save :: zpoptcv ! VI optical properties of clouds within narrowbands for diags (dtau,tau,k,wbar,gbar).
+!$OMP THREADPRIVATE(zpopthi,zpopthv,zpoptci,zpoptcv)
+
+      real,dimension(:,:),allocatable,save :: u_ref ! Reference profile for the zonal wind nudging (m.s-1).
+!$OMP THREADPRIVATE(u_ref)
 
       real,allocatable,dimension(:,:),save :: qsurf_hist
@@ -130,4 +139,9 @@
         ALLOCATE(int_dtaui(klon,klev,L_NSPECTI))
         ALLOCATE(int_dtauv(klon,klev,L_NSPECTV))
+        ALLOCATE(zpopthi(klon,klev,L_NSPECTI,5))
+        ALLOCATE(zpopthv(klon,klev,L_NSPECTV,5))
+        ALLOCATE(zpoptci(klon,klev,L_NSPECTI,5))
+        ALLOCATE(zpoptcv(klon,klev,L_NSPECTV,5))
+        ALLOCATE(u_ref(49,24))
         allocate(dycchi(klon,klev,nkim))
         ! This is defined in comsaison_h
@@ -191,4 +205,9 @@
         DEALLOCATE(int_dtaui)
         DEALLOCATE(int_dtauv)
+        DEALLOCATE(zpopthi)
+        DEALLOCATE(zpopthv)
+        DEALLOCATE(zpoptci)
+        DEALLOCATE(zpoptcv)
+        DEALLOCATE(u_ref)
         DEALLOCATE(dycchi)
         DEALLOCATE(mu0)
